#!/usr/bin/python2.5
"""Sample ss activation program."""
import socket, os
import bitfrost.util.json as json
#ipv4=(os.fork()==0)
#if ipv4: # IPv4
#    FAMILY = socket.AF_INET
#    BIND = ('172.18.0.1', 191)
#else: # IPv6
from ipv6util import if_nametoindex
FAMILY = socket.AF_INET6
BIND = ('fe80::abcd:ef01', 191, 0, if_nametoindex('msh0'))
s = socket.socket(FAMILY, socket.SOCK_STREAM)
s.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
if hasattr(socket, 'SO_REUSEPORT'):
    s.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEPORT, 1)
s.bind(BIND)
s.listen(20)

# Preload lease file
print "Reading leases, please wait."
leases = json.read(open('lease.sig').read())
print "Loaded %d leases. Serving..." % len(leases[1].keys())

def _recv(conn, buflen):
    buf = ''
    while len(buf) < buflen:
        buf += conn.recv(buflen-len(buf))
        if buflen < len(buf): print "Partial reception:", buf
    return buf

while True:
    # reap any zombies
    try:
        while True:
            pid, st = os.waitpid(0, os.WNOHANG)
            if pid == 0: break
    except OSError:
        pass # no children
    # accept another connection.
    conn, addr = s.accept()
    if os.fork()!=0:
        conn.close()
        continue
    print "Connected by", addr
    sn = _recv(conn, 11)
    #sn = conn.recv(1024)
    print "Received", sn
    conn.shutdown(socket.SHUT_RD)
    conn.send(leases[1][sn])
    print "Sent reply message."
    conn.shutdown(socket.SHUT_WR)
    conn.close()
    print "Closed socket."
    break
